function rhofull=bndcurve(the)
% evaluates periodic curve in polar coordinates
global domainindex
global domainangle
ith=find(the<0);
the(ith)=the(ith)+2*pi;
if (domainindex==1) % unit circle
    rho=ones(size(the));
    rhoder=zeros(size(the));
    rhofull=[rho ;rhoder];
    return
end
if (domainindex==5) % amoeba
    rho=0.35*ones(size(the)).*(exp(sin(the)).*sin(2*the).^2+...
        exp(cos(the)).*cos(2*the).^2);
    rhoder=ones(size(the))*0.35.*(...
        exp(sin(the)).*sin(2*the).*(4*cos(2*the)+sin(2*the).*cos(the))-...
        exp(cos(the)).*cos(2*the).*(4*sin(2*the)+cos(2*the).*sin(the))...
        );
    rhofull=[rho ;rhoder];   
end
if (domainindex==2) % deformed circle with corners
    rho=ones(size(the)).*(1+abs(the))/4.2;
    rhoder=ones(size(the)).*sign(the)/4.2;
    rhofull=[rho ;rhoder];
    return;
end
if (domainindex==6) % cardioid
    c=0.5*sqrt(tan(domainangle));
    rho=ones(size(the)).*sqrt(c.^2+abs(sin(the/2)))/sqrt(c.^2+1);
    rhoder=ones(size(the)).*...
        sign(sin(the/2)).*cos(the/2)*0.5...
        ./(2*sqrt(c.^2+abs(sin(the/2)))*sqrt(c.^2+1));
    rhofull=[rho ;rhoder];
    
    return;
end
if (domainindex==7) % ?????
    rho=ones(size(the)).*sqrt(1+0.5*sin(4*the))/sqrt(2);
    return;
end
if (domainindex==3) % unit rectangle
    [x y]=pol2cart(the,ones(size(the)));
    ri=find(cos(the)>=cos(pi/4));
    le=find(cos(the)<=cos(3*pi/4));
    to=find(abs(the-pi/2)<pi/4);
    lo=find(abs(the-3*pi/2)<=pi/4);
    % ss=sqrt(2);
    ss=1;
    rho(ri)=ones(size(the(ri)))./abs(cos(the(ri)))/ss;
    rho(le)=ones(size(the(le)))./abs(cos(the(le)))/ss;
    rho(to)=ones(size(the(to)))./abs(sin(the(to)))/ss;
    rho(lo)=ones(size(the(lo)))./abs(sin(the(lo)))/ss;
    rhoder=zeros(size(the));
    rhoder(ri)= sin(the(ri)).*sign(cos(the(ri)))./cos(the(ri)).^2/ss;
    rhoder(le)= sin(the(le)).*sign(cos(the(le)))./cos(the(le)).^2/ss;
    rhoder(to)=-cos(the(to)).*sign(sin(the(to)))./sin(the(to)).^2/ss;
    rhoder(lo)=-cos(the(lo)).*sign(sin(the(lo)))./sin(the(lo)).^2/ss;
    rhofull=[rho ;rhoder];  
    return
end
